# /packages/intranet-core/www/users/nuke-2.tcl
#
# Copyright (C) 1998-2004 various parties
# The code is based on ArsDigita ACS 3.4
#
# This program is free software. You can redistribute it
# and/or modify it under the terms of the GNU General
# Public License as published by the Free Software Foundation;
# either version 2 of the License, or (at your option)
# any later version. This program is distributed in the
# hope that it will be useful, but WITHOUT ANY WARRANTY;
# without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.

ad_page_contract {
    Remove a user from the system completely

    @author various@arsdigita.com
    @author frank.bergmann@project-open.com
} {
    user_id:integer,notnull
}

# When there's a real orders table or system in place, 
# n_orders should be set to the result of a query that determines
# if the user has any orders
set n_orders 0

# Don't nuke anyone who pays us money ...
if { $n_orders > 0 } {
    ad_return_error "[_ intranet-core.lt_Cant_Nuke_a_Paying_Co]" "[_ intranet-core.lt_We_cant_nuke_a_paying]"
    return
}

# have no mercy on the freeloaders

# if this fails, it will probably be because the installation has 
# added tables that reference the users table

with_transaction {
    # education module
    # TO DO: IF YOU UNCOMMENT THESE, MAKE USER_ID A BIND VARIABLE
    # This is assumes that all info added by a user is no longer wanted
    #db_dml unused "delete from edu_department_info where last_modifiying_user = :user_id"
    #db_dml unused "delete from edu_subjects where last_modifiying_user = :user_id"
    #db_dml unused "delete from edu_class_info where last_modifiying_user = :user_id"
    #db_dml unused "delete from edu_grades where last_modifiying_user = :user_id"
    #db_dml unused "delete from edu_student_tasks where assigned_by = $user_id"
    #db_dml unused "delete from edu_student_answers where student_id = $user_id"
    #db_dml unused "delete from edu_student_answers where student_id = $user_id"
    #db_dml unused "delete from edu_student_evaluations where student_id = $user_id"
    #db_dml unused "delete from edu_student_evaluations where grader_id = $user_id"
    #db_dml unused "delete from edu_student_evaluations where last_modifying_user = $user_id"
    #db_dml unused "delete from edu_task_instances where approving_user = $user_id"
    #db_dml unused "delete from edu_task_user_map where student_id = $user_id"
    #db_dml unused "delete from edu_appointments where user_id = $user_id"
    #db_dml unused "delete from edu_appointments_scheduled where user_id = $user_id"
    #db_dml unused "delete from portal_weather where user_id = $user_id"
    #db_dml unused "delete from portal_stocks where user_id = $user_id"
    #db_dml unused "delete from edu_calendar where owner = $user_id"
    #db_dml unused "delete from edu_calendar where creation_user = $user_id"
    

    # bboard system
    db_dml delete_user_bboard_email_alerts "delete from bboard_email_alerts where user_id = :user_id"
    db_dml delete_user_bboard_thread_email_alerts "delete from bboard_thread_email_alerts where user_id = :user_id"
    db_dml delete_user_bboard_unified "delete from bboard_unified where user_id = :user_id"
    
    # deleting from bboard is hard because we have to delete not only a user's
    # messages but also subtrees that refer to them
    bboard_delete_messages_and_subtrees_where  -bind [list user_id $user_id] "user_id = :user_id"
    
    # let's do the classifieds now
    db_dml delete_user_classified_auction_bids "delete from classified_auction_bids where user_id = :user_id"
    db_dml delete_user_classified_ads "delete from classified_ads where user_id = :user_id"
    db_dml delete_user_classified_email_alerts "delete from classified_email_alerts where user_id = :user_id"
    db_dml delete_user_neighbor_to_neighbor_comments "delete from general_comments 
 where on_which_table = 'neighbor_to_neighbor'
 and on_what_id in (select neighbor_to_neighbor_id 
                   from neighbor_to_neighbor 
                   where poster_user_id = :user_id)"
    db_dml delete_user_neighbor_to_neighbor "delete from neighbor_to_neighbor where poster_user_id = :user_id"
    # now the calendar
    db_dml delete_user_calendar "delete from calendar where creation_user = :user_id"
    # contest tables are going to be tough
    set all_contest_entrants_tables [db_list unused "select entrants_table_name from contest_domains"]
    foreach entrants_table $all_contest_entrants_tables {
	db_dml delete_user_contest_entries "delete from $entrants_table where user_id = :user_id"
    }

    # spam history
    db_dml delete_user_spam_history "delete from spam_history where creation_user = :user_id"
    db_dml delete_user_spam_history_sent "update spam_history set last_user_id_sent = NULL
                    where last_user_id_sent = :user_id"

    # calendar
    db_dml delete_user_calendar_categories "delete from calendar_categories where user_id = :user_id"

    # sessions
    db_dml delete_user_sec_sessions "delete from sec_sessions where user_id = :user_id"
    db_dml delete_user_sec_login_tokens "delete from sec_login_tokens where user_id = :user_id"
    
    # general stuff
    db_dml delete_user_general_comments "delete from general_comments where user_id = :user_id"
    db_dml delete_user_comments "delete from comments where user_id = :user_id"
    db_dml delete_user_links "delete from links where user_id = :user_id"
    db_dml delete_user_chat_msgs "delete from chat_msgs where creation_user = :user_id"
    db_dml delete_user_query_strings "delete from query_strings where user_id = :user_id"
    db_dml delete_user_user_curriculum_map "delete from user_curriculum_map where user_id = :user_id"
    db_dml delete_user_user_content_map "delete from user_content_map where user_id = :user_id"
    db_dml delete_user_user_group_map "delete from user_group_map where user_id = :user_id"

    # core tables
    db_dml delete_user_users_interests "delete from users_interests where user_id = :user_id"
    db_dml delete_user_users_charges "delete from users_charges where user_id = :user_id"
    db_dml set_referred_null_user_users_demographics "update users_demographics set referred_by = null where referred_by = :user_id"
    db_dml delete_user_users_demographics "delete from users_demographics where user_id = :user_id"
    db_dml delete_user_users_preferences "delete from users_preferences where user_id = :user_id"
    db_dml delete_user_users_contact "delete from users_contact where user_id = :user_id"
    db_dml delete_user "delete from users where user_id = :user_id"
} {
    
    set detailed_explanation ""

    if {[ regexp {integrity constraint \([^.]+\.([^)]+)\)} $errmsg match constraint_name]} {
	
	set sql "select table_name from user_constraints 
	where constraint_name=:constraint_name"

	db_foreach user_constraints_by_name $sql {
	    set detailed_explanation "<p>
	    [_ intranet-core.lt_It_seems_the_table_we]"
	}
    }

    ad_return_error "[_ intranet-core.Failed_to_nuke]" "[_ intranet-core.lt_The_nuking_of_user_us]

$detailed_explanation

<p>

[_ intranet-core.lt_For_good_measure_here]

<blockquote>
<pre>
$errmsg
</pre>
</blockquote>"
    return
}

set return_to_admin_link "<a href=\"/intranet/users/\">[_ intranet-core.lt_return_to_user_admini]</a>" 

set page_content "[ad_admin_header "[_ intranet-core.Done]"]

<h2>[_ intranet-core.Done]</h2>

<hr>

[_ intranet-core.lt_Weve_nuked_user_user_]

[ad_admin_footer]
"


doc_return  200 text/html $page_content
